Last updated

API / geotoolkit / map / sources / CompositeSource / CompositeSource

Class: CompositeSource

sources.CompositeSource.CompositeSource

Composite source that stores multiple vector sources for centralized control and processing

Hierarchy

Table of contents

Constructors
Methods
Css Properties
Name Type Description
systemstringInitial data coordinate system
urlstringData server url

Contents

Constructors

new CompositeSource(options)

new CompositeSource(options?)

Parameters

Name Type Description
Optional optionsOptionssource(s) for storing or properties object

Overrides

Vector.constructor

Methods

addFeatureSource

addFeatureSource(source): CompositeSource

Adds vector source to the list for getting new features

Parameters

Name Type Description
sourceVectorsource to add

Returns

CompositeSource

this


addFeatures

addFeatures(features, needTransform?): CompositeSource

Notifies source to add features.

Parameters

Name Type Description
featuresAbstractFeature[]features to add
Optional needTransformbooleantrue if features should be transformed to the map coordinates

Returns

CompositeSource

this

Inherited from

Vector.addFeatures


clear

clear(): CompositeSource

Notifies source to remove all features added.

Returns

CompositeSource

this

Overrides

Vector.clear


clearFeatures

clearFeatures(): CompositeSource

Notifies source to remove all features added.

Returns

CompositeSource

this

Inherited from

Vector.clearFeatures


dispose

dispose(): void

Disposes this source, once disposes a node should not be used anymore.

Returns

void

Overrides

Vector.dispose


getClassName

getClassName(): string

Returns

string

Inherited from

Vector.getClassName


getCopyright

getCopyright(): string

Returns copyright information.

Returns

string

Inherited from

Vector.getCopyright


getDataLoader

Protected getDataLoader(): AbstractLoader

Returns server data loader (if exists)

Returns

AbstractLoader

Inherited from

Vector.getDataLoader


getFeatureSourceList

getFeatureSourceList(): Vector[]

Gets current sources list used to add a new features

Returns

Vector[]


getInitialCoordinateSystem

getInitialCoordinateSystem(): AbstractSystem

Gets current data initial coordinate system.

Returns

AbstractSystem

Inherited from

Vector.getInitialCoordinateSystem


getMapCoordinateSystem

getMapCoordinateSystem(): AbstractSystem

Gets current map coordinate system.

Returns

AbstractSystem

Inherited from

Vector.getMapCoordinateSystem


getModelLimits

getModelLimits(): Rect

Returns the current data model limits (presumably loaded from the server if it's settled)

Returns

Rect

Inherited from

Vector.getModelLimits


getProperties

getProperties(): OptionsOut

Returns properties

Returns

OptionsOut

properties

Inherited from

Vector.getProperties


getRequestResolution

getRequestResolution(): number

Gets the grid size for layer partitioning that is used for server requests

Returns

number

Inherited from

Vector.getRequestResolution


getServerData

getServerData(): JSONObject | XMLDocument

Returns server data loaded from the server Should be used asynchronically after loadServerData() method is called

Returns

JSONObject | XMLDocument

Inherited from

Vector.getServerData


getServerURL

getServerURL(): string | string[]

Gets the server url that is currently used for requests

Returns

string | string[]

server url

Inherited from

Vector.getServerURL


getTransformerFromMap

getTransformerFromMap(): Transformer

Gets transformer to transform data from map coordinate system

Returns

Transformer

Inherited from

Vector.getTransformerFromMap


getTransformerToMap

getTransformerToMap(): Transformer

Gets transformer to transform data to map coordinate system

Returns

Transformer

Inherited from

Vector.getTransformerToMap


getUniqueField

getUniqueField(): string

Gets the unique identifier for the dataset

Returns

string

field

Inherited from

Vector.getUniqueField


hasEventListener

hasEventListener(type, callback?): boolean

Check if a list of event listeners for this type contains this listener

Parameters

Name Type Description
typestringtype of event or property
Optional callbackFunctionto be called, if null, check if any callback is registered

Returns

boolean

Inherited from

Vector.hasEventListener


initLoader

Protected initLoader(loader?): CompositeSource

Initializes the loader provided

Parameters

Name Type Description
Optional loaderAbstractLoaderloader to use

Returns

CompositeSource

this

Inherited from

Vector.initLoader


isDataLoaded

isDataLoaded(): boolean

Returns true if server data is already loaded (or no loader provided)

Returns

boolean

Inherited from

Vector.isDataLoaded


isDataReady

isDataReady(): boolean

Checks if source (current visible) data is loaded and ready to be rendered

Returns

boolean

Inherited from

Vector.isDataReady


isDisposed

isDisposed(): boolean

Returns whether this object has been disposed

Returns

boolean

Inherited from

Vector.isDisposed


isLoading

isLoading(): boolean

Checks if some of the requests haven't been finished yet. Returns true if some data is loading, false otherwise.

Returns

boolean

Inherited from

Vector.isLoading


isSilent

isSilent(): boolean

Return true if the event dispatcher doesn't notify any events

Returns

boolean

Inherited from

Vector.isSilent


loadServerData

loadServerData(): Promise<CompositeSource>

Returns promise that is loaded when server settings are ready to process

Returns

Promise<CompositeSource>

Inherited from

Vector.loadServerData


loadSourceData

loadSourceData(): Promise<AbstractSource>

Returns promise that is resolving when data are ready to process

Returns

Promise<AbstractSource>

Inherited from

Vector.loadSourceData


notify

notify<E>(type, source, args?): CompositeSource

Notify listeners

Type parameters

NameType
Eextends string

Parameters

Name Type Description
typeEevent types
sourceVectorof the event
Optional argsEventMap[E]arguments of the event

Returns

CompositeSource

this

Inherited from

Vector.notify


off

off<E>(type?, callback?): CompositeSource

Detach listener on event. Calling .off() with no arguments removes all attached listeners. Calling .off(type) with no callback removes all attached listeners for specific type.

Type parameters

NameType
Eextends string

Parameters

Name Type Description
Optional typeEtype of the event
Optional callback(eventType: E, sender: CompositeSource, args: EventMap[E]) => voidfunction to be called

Returns

CompositeSource

this

Inherited from

Vector.off


on

on<E>(type, callback): CompositeSource

Attach listener on event that will be called whenever the specified event is delivered to the target

If the callback function is already in the list of event listeners for this target, the function is not added a second time.

If a particular anonymous function is in the list of event listeners registered for a certain target, and then later in the code, an identical anonymous function is given in an "on" call, the second function will also be added to the list of event listeners for that target.

Type parameters

NameType
Eextends string

Parameters

Name Type Description
typeEtype of event or property
callback(eventType: E, sender: CompositeSource, args: EventMap[E]) => voidto be called

Returns

CompositeSource

this

Inherited from

Vector.on


queryFeatures

queryFeatures(bbox, layer): CompositeSource

Sends a request for features in given bounding box.

Parameters

Name Type Description
bboxRectbounding box for features
layerAbstractFeatureLayerlayer requesting

Returns

CompositeSource

this

Inherited from

Vector.queryFeatures


removeFeature

removeFeature(feature): CompositeSource

Notifies source to remove feature.

Parameters

Name Type Description
featureAbstractFeaturefeature to remove

Returns

CompositeSource

this

Inherited from

Vector.removeFeature


removeFeatureSource

removeFeatureSource(source): CompositeSource

Removes source from the sources list

Parameters

Name Type Description
sourceVectorsource to remove

Returns

CompositeSource

this


requestData

requestData(resource): void

Requests data from the resource and parses the response

Parameters

Name Type Description
resourcestringresource url for request

Returns

void

Inherited from

Vector.requestData


resetLastQueryParams

Protected resetLastQueryParams(): CompositeSource

Resets saved last queried limits and layer

Returns

CompositeSource

this

Inherited from

Vector.resetLastQueryParams


setDataReady

Protected setDataReady(isReady, err?): CompositeSource

Sets source (current visible) data ready/not ready, changes the corresponding promise

Parameters

Name Type Description
isReadybooleantrue if source data was loaded, false if it needs to be reset
Optional errErrordata loading error (if exists)

Returns

CompositeSource

this

Inherited from

Vector.setDataReady


setInitialCoordinateSystem

setInitialCoordinateSystem(system): CompositeSource

Sets initial features coordinate system.

Parameters

Name Type Description
systemAbstractSysteminitial coordinate system

Returns

CompositeSource

this

Overrides

Vector.setInitialCoordinateSystem


setMapCoordinateSystem

setMapCoordinateSystem(system): CompositeSource

Sets map coordinate system.

Parameters

Name Type Description
systemstring | AbstractSystemmap coordinate system

Returns

CompositeSource

this

Overrides

Vector.setMapCoordinateSystem


setProperties

setProperties(properties?): CompositeSource

Sets properties

Parameters

Name Type Description
Optional propertiesOptionsproperties

Returns

CompositeSource

this

Inherited from

Vector.setProperties


setQueryParameter

setQueryParameter(param, value?): CompositeSource

Sets custom query parameter to add to the data requests

Parameters

Name Type Description
paramstring | Record<string, string | number>parameter name or custom parameters object (in name -> value format)
Optional valuestring | numberparameter value

Returns

CompositeSource

this

Inherited from

Vector.setQueryParameter


setRequestResolution

setRequestResolution(resolution): CompositeSource

Sets the grid size for layer partitioning that is used for server requests

Parameters

Name Type Description
resolutionnumbergrid size

Returns

CompositeSource

this

Overrides

Vector.setRequestResolution


setServerURL

setServerURL(url): CompositeSource

Sets the server url to use for requesting

Parameters

Name Type Description
urlstring | string[]server url

Returns

CompositeSource

this

Inherited from

Vector.setServerURL


setSilent

setSilent(bool): CompositeSource

Set silent mode

Parameters

Name Type Description
boolbooleanflag to enable silent mode

Returns

CompositeSource

this

Inherited from

Vector.setSilent


setUniqueField

setUniqueField(field): CompositeSource

Sets the unique identifier for the features

Parameters

Name Type Description
fieldstringunique identifier

Returns

CompositeSource

this

Overrides

Vector.setUniqueField


update

update(): CompositeSource

Aborts all the sent requests, resends the last one

Returns

CompositeSource

this

Inherited from

Vector.update


getClassName

Static getClassName(): string

Returns

string

Inherited from

Vector.getClassName